#include "mainwindow.h"
#include "ui_mainwindow.h"

#include "testwidget.h"
#include <xcb/xcb.h>
#include <xcb/xproto.h>
#include <xcb/xinput.h>
MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    connect(ui->pushButton, SIGNAL( clicked(bool) ), this, SLOT( clicked1( bool ) ));
    connect(ui->pushButton_2, SIGNAL( clicked(bool) ), this, SLOT( clicked2( bool ) ));
    QCoreApplication::instance()->installNativeEventFilter( new AsFilterManagerAppEventFilter() );

}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::clicked1(bool checked)
{
    testWidget *test = new testWidget(this);
    test->show();
    qDebug() << " MainWindow::clicked1 ";
}

void MainWindow::clicked2(bool checked)
{
    qDebug() << " MainWindow::clicked2 ";
}

bool AsFilterManagerAppEventFilter::nativeEventFilter(const QByteArray &eventType, void *message, qintptr *result)
{
    Q_UNUSED(eventType);

    Q_UNUSED(result);

    int type = 0;
    xcb_generic_event_t * xev = reinterpret_cast<xcb_generic_event_t *>(message);
    if( xev->response_type == XCB_GE_GENERIC )
    {
        xcb_input_button_press_event_t * xiEvent = reinterpret_cast<xcb_input_button_press_event_t *>(message);
        type = xiEvent->event_type;
    }

    if (type == XCB_INPUT_TOUCH_BEGIN )
    {
        qDebug() << " XCB_INPUT_TOUCH_BEGIN ";
    }
    else if (type == XCB_INPUT_TOUCH_UPDATE )
    {
        qDebug() << " XCB_INPUT_TOUCH_UPDATE ";
    }
    else if (type == XCB_INPUT_TOUCH_END )
    {
        qDebug() << " XCB_INPUT_TOUCH_END ";
    }

    return false;
}
